using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.Reflection;

namespace DevSummit
{
	/// <summary>
	/// MoreDICon ̊Tv̐łB
	/// </summary>
	public class MoreDICon
	{
		Hashtable objects;
		Hashtable properties;
		public MoreDICon(Hashtable initObjs, Hashtable initProps)
		{
			objects = initObjs;
			properties = initProps;
			ReadConfig("properties", new ValueHandler(propRead));
		}
		delegate void ValueHandler(string key, string val);
		void propRead(string key, string val)
		{
			properties.Add(key, val);
		}
		void classRead(string key, string val)
		{
			Type tp = Type.GetType(val);
			ConstructorInfo[] cis = tp.GetConstructors();
			foreach (ConstructorInfo ci in cis)
			{
				ParameterInfo[] pis = ci.GetParameters();
				object[] pars = new object[pis.Length];
				bool found = true;
				for (int i = 0; i < pis.Length; i++)
				{
					string s = (string)properties[pis[i].Name];
					if (s == null)
					{
						found = false;
						break;
					}
					pars[i] = Convert.ChangeType(s, pis[i].ParameterType);
				}
				if (found)
				{
					objects.Add(tp, ci.Invoke(pars));
				}
			}
		}

		public void create()
		{
			ReadConfig("objects", new ValueHandler(classRead));
		}

		public void inject()
		{
			foreach (DictionaryEntry target in objects)
			{
				Type tp = (Type)target.Key;
				PropertyInfo[] pis = tp.GetProperties(BindingFlags.DeclaredOnly | BindingFlags.Public | BindingFlags.SetProperty | BindingFlags.Instance);
				foreach (PropertyInfo pi in pis)
				{
					MethodInfo mi = pi.GetSetMethod();
					if (mi == null || mi.GetParameters().Length != 1)
					{
						continue;
					}
					setValues(pi, mi, target.Value);
					setObjects(pi, mi, target.Value);
				}
			}
		}
		void setObjects(PropertyInfo pi, MethodInfo mi, object target)
		{
			ParameterInfo pari = mi.GetParameters()[0];
			if (pari.ParameterType.IsPrimitive 
				|| pari.ParameterType.Equals(typeof(string)))
			{
				return;
			}
			foreach (DictionaryEntry obj in objects)
			{
				if (pari.ParameterType.IsInstanceOfType(obj.Value))
				{
					mi.Invoke(target, new object[] { obj.Value });
				}
			}
		}
		void setValues(PropertyInfo pi, MethodInfo mi, object target)
		{
			string s = (string)properties[Char.ToLower(pi.Name[0]) + pi.Name.Substring(1)];
			if (s != null && pi.GetSetMethod().GetParameters().Length == 1)
			{
				pi.GetSetMethod().Invoke(target, new object[] 
						{ Convert.ChangeType(s, pi.GetSetMethod().GetParameters()[0].ParameterType) });
			}
		}

		void ReadConfig(string sectionName, ValueHandler hnd)
		{
			NameValueCollection section 
				= (NameValueCollection)ConfigurationSettings.GetConfig(sectionName);
			foreach (string key in section.AllKeys)
			{
				foreach (string val in section.GetValues(key))
				{
					hnd(key, val);
				}
			}
		}
	}
}
